<template>
    <v-container>
        <div style="height: 70vh; width: 100%">
            <l-map :zoom="zoom" :center="[points[1].latitude, points[1].longitude]">
                <l-control-layers position="topright"></l-control-layers>

                <l-tile-layer
                        v-for="tileProvider in tileProviders"
                        :key="tileProvider.name"
                        :name="tileProvider.name"
                        :visible="tileProvider.visible"
                        :url="tileProvider.url"
                        :attribution="tileProvider.attribution"
                        layer-type="base"/>
<!--                <l-geo-json-->
<!--                        :geojson="geojson"-->
<!--                        :options="options"-->
<!--                        :options-style="styleFunction"-->
<!--                />-->
                <l-marker v-for="point in points" :key="point.id" :lat-lng="[point.latitude, point.longitude]">
                    <!--                    <l-icon :icon-size="[50, 50]" :iconAnchor="[25, 25 ]" >-->

                    <!--                    </l-icon>-->
                    <l-tooltip :options="{ permanent: true, className: 'custom-tooltip '+ point.urgence}"
                               :content="point.fic + ''">
                        <!--                        <span>{{point.fic}}</span>-->
                    </l-tooltip>
                </l-marker>
            </l-map>
        </div>
    </v-container>
</template>

<script>
    import {LControlLayers, LMap, LMarker, LTileLayer, LTooltip} from "vue2-leaflet";
    import {latLng} from "leaflet";

    export default {
        name: "map",
        components: {
            LMap,
            LTileLayer,
            LMarker,
            LTooltip,
            LControlLayers,

        },
        props: {
            points: null,
        },
        data: () => ({
            iconUrl: require('../assets/blue_pastille.png'),
            zoom: 13,
            baseUrlParcelle: "https://cadastre.data.gouv.fr/bundler/cadastre-etalab/communes/" + 'code insee ville'+ "/geojson/parcelles",
            tileProviders: [
                // {
                //     name: 'Satellite',
                //     url: "https://wxs.ign.fr/j5rx5g2g390bz3vyzvmvktd4/geoportail/wmts?" +
                //         "&REQUEST=GetTile&SERVICE=WMTS&VERSION=1.0.0" +
                //         "&STYLE=normal" +
                //         "&TILEMATRIXSET=PM" +
                //         "&FORMAT=image/jpeg" +
                //         "&LAYER=ORTHOIMAGERY.ORTHOPHOTOS" +
                //         "&TILEMATRIX={z}" +
                //         "&TILEROW={y}" +
                //         "&TILECOL={x}",
                //     attribution: "IGN-F/Geoportail",
                //     options: {
                //         minZoom: 0,
                //         tileSize: 256 // les tuiles du Géooportail font 256x256px
                //     }
                // },
                {
                    name: 'Parcelle',
                    url: "https://wxs.ign.fr/an7nvfzojv5wa96dsga5nk8w/geoportail/wmts?" +
                        "&REQUEST=GetTile" +
                        "&VERSION=1.0.0" +
                        "&Service=WMTS" +
                        "&style=PCI%20vecteur" +
                        "&TILEMATRIXSET=PM" +
                        "&FORMAT=image/png" +
                        "&layer=CADASTRALPARCELS.PARCELLAIRE_EXPRESS" +
                        "&TILEMATRIX={z}" +
                        "&TILEROW={y}" +
                        "&TILECOL={x}",
                    attribution: "IGN-F/Geoportail",
                    options: {
                        minZoom: 0,
                        tileSize: 256 // les tuiles du Géooportail font 256x256px
                    }
                },
                {
                    name: 'Street',
                    url: 'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
                    attribution:
                        '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors',
                },
            ],
            geojson: null,
            fillColor: "#e4ce7f",

        }),
        computed: {
            center() {
                if (this.points.length === 0) {
                    return latLng(48.5023928, -2.8963237)
                } else {
                    return latLng(this.points[1].latitude, this.points[1].longitude)
                }
            },
            options() {
                return {
                    onEachFeature: this.onEachFeatureFunction
                };
            },
            styleFunction() {
                const fillColor = this.fillColor; // important! need touch fillColor in computed for re-calculate when change fillColor
                return () => {
                    return {
                        weight: 2,
                        color: "#ECEFF199",
                        opacity: 1,
                        fillColor: fillColor,
                        fillOpacity: 1
                    };
                };
            },
            onEachFeatureFunction() {
                return (feature, layer) => {
                    layer.bindTooltip(
                        "<div class='custom-tooltip'>" +
                        feature.properties.numero +
                        "</div>",
                        { permanent: true, sticky: true }
                    );
                };
            }
        },
        async created() {
            const response = await fetch("https://cadastre.data.gouv.fr/bundler/cadastre-etalab/communes/22256/geojson/parcelles")

            const data = await response.json();

            this.geojson = data;
            this.loading = false;
        }
    }
</script>

<style>
    .custom-tooltip::before {
        border-color: transparent !important;
    }

    .custom-tooltip {
        border: none !important;
        background: transparent !important;
        box-shadow: none !important;
        font-size: medium;
    }

    .U0 {
        color: red !important;
        font-weight: bold;
    }

    .U1 {
        color: darkorange !important;
        font-weight: bold;
    }

    .U2 {
        color: lime !important;
        font-weight: bold;
    }
</style>